import es
import playerlib
import vecmath
import gamethread
from JoeyCMDs import JoeyCMDs

est = JoeyCMDs("est")

thermal_players = set() 

#######################################
#SERVER VARIABLES

use_overlay = es.ServerVar("use_overlay", "effects/combine_binocoverlay.vmt", "What overlay should be used?")
see_thru_walls_sprite = es.ServerVar("see_thru_walls_sprite", "effects/strider_bulge_dudv_dx60.vmt", "Special seen thru walls sprites")
refresh_rate = es.ServerVar("refresh_rate", 0.1, "Sprite refresh rate")
minimum_distance = es.ServerVar("minimum_distance", 300, "Minimum distance at wich alpha is max = 255")
maximum_distance = es.ServerVar("maximum_distance", 2000, "Maximum distance at wich alpha is max = 0")
mods = es.ServerVar("mods", 1, "1 = Anyone press thermal bind button - 2 = Only team bind button - 3 = Only team automatic")
wich_team = es.ServerVar("wich_team", 1, "1 = Terrorists 2 = CT")
'''
sprites/lgtning_noz.vmt
sprites/physcannon_bluecore1b.vmt
sprites/crosshairs.vmt 
sprites/640hud9.vmt 
effects/strider_bulge_dudv_dx60.vmt
'''

#######################################
# ADDON INFORMATION
info = es.AddonInfo()
info.name           = "Thermal goggles"
info.version        = "1.2"
info.author         = "Juba_PornBorn"
info.url            = "http://addons.eventscripts.com/addons/view/"
info.description    = "Gives thermal vision goggles to users"

#######################################

def load():
    es.ServerVar("thermal_vision", info.version).makepublic()
    
	es.regclientcmd('!thermal', 'thermal/start', "Start thermal vision")
		
    es.dbgmsg(0,"[Thermal goggles] Loaded")

def es_map_start(event_var): 
    thermal_players.clear()

def player_spawn(ev):
	global mods
	global wich_team
	
	userteam = ev(es_userteam)
	userid = ev(userid)
	if mods == 3:
		if userteam == wich_team:
			if userid not in thermal_players:
				start_aftercheck(userid)
				
def start():
	global mods
	global wich_team
	
	usercmd = es.getcmduserid()
	player = playerlib.getPlayer(usercmd)
	
	if mods == 1:
		start_aftercheck(player)
	if mods == 2 and player.getplayer('teamid') == wich_team:
		start_aftercheck(player)

def start_aftercheck(userid):
	
    if userid in thermal_players: 
        thermal_players.remove(userid) 
        if not thermal_players: 
            gamethread.cancelDelayed('thermal_loop') 

        es.emitsound('player', userid, "weapons/zoom.wav", 0.7, 0.5) 
        es.cexec(userid, "r_screenoverlay 0") 

    else: 
        if playerlib.getPlayer(userid).get('isdead'): 
            es.tell(userid, 'You cannot use that command while dead') 

        else:
				es.emitsound('player', userid, "ambient/office/button1.wav", 0.7, 0.5) 
				es.cexec(userid, "r_screenoverlay %s"%use_overlay) 

				if not thermal_players: # Start the loop if this is the first player 
					gamethread.delayedname(refresh_rate, 'thermal_loop', loopers)
				
				thermal_players.add(userid) 

def loopers():
    for userid in thermal_players:
        for user in filter(lambda x:not x == userid and not es.getplayerprop(x, 'CBasePlayer.pl.deadflag'), es.getUseridList()):
            x, y, z = es.getplayerlocation(user)
            userv = vecmath.vector(es.getplayerlocation(user))
            useridv = vecmath.vector(es.getplayerlocation(userid))
            distance = vecmath.distance(userv, useridv)
            # sets minimum distance
            alpha = 255 * minimum_distance / distance
            # sets maximum distance
            if distance >= maximum_distance:
                alpha = 0
            # maximum and minimum integer preventer
            if alpha > 255:
                alpha = 255
            elif alpha < 0:
                alpha = 0
            #es.msg('alpha: %s distance: %s'%(alpha, distance))        
            #<x> <y> <z> <start radius> <end radius> <life> <width> <spread> <amplitude> <Red> <Green> <Blue> <Alpha> <speed> 
            #es.server.queuecmd('est_effect 10 %s 0 %s %s %s %s 30 50 0.1 50 0 0 255 100 100 255 0' % (userid, see_thru_walls_sprite, x, y, z + 50)) 
            est.effect(11, userid, 0,see_thru_walls_sprite, x, y, z + 20, refresh_rate, 1, int(alpha))
    gamethread.delayedname(refresh_rate, 'thermal_loop', loopers) 

def unload():
    es.dbgmsg(0,"[Thermal goggles] Unloaded")
    gamethread.cancelDelayed('thermal_loop')